package org.iotivity.bridge.homeserver.handler.client;

import android.util.Log;

import org.iotivity.OCClientResponse;
import org.iotivity.OCQos;
import org.iotivity.OCResponseHandler;
import org.iotivity.OCStatus;
import org.iotivity.bridge.homeserver.BridgeService;
import org.iotivity.bridge.homeserver.utils.Utils;
import org.iotivity.oc.OcRemoteResource;
import org.iotivity.oc.OcUtils;
import org.json.JSONException;
import org.json.JSONObject;

public class PutResponseHandler implements OCResponseHandler {

    private static final String TAG = PutResponseHandler.class.getSimpleName();

    private BridgeService service ;
    private OcRemoteResource resource ;

    public PutResponseHandler(BridgeService service, OcRemoteResource resource) {
        this.service = service;
        this.resource = resource ;
    }

    @Override
    public void handler(OCClientResponse response) {

        Log.d(TAG, "PUT "+resource.getUri()+" Response Handler: Code = "+response.getCode().toString());
        if(response.getCode() != OCStatus.OC_STATUS_CHANGED && response.getCode() != OCStatus.OC_STATUS_CREATED) {
            return;
        }

        /* TODO : check if it needs for broadcast POST/PUT Result
         *  because Requesting Post call's result was already returned in Interface API call
         *  (eg. public boolean requestPostProperties(String device_uuid, String resource_uri, String prop_data))
         *
        try {

            JSONObject result = new JSONObject();
            result.put("id", resource.getAnchor() + resource.getUri());
            result.put("di", Utils.getDIFromAnchor(resource.getAnchor()));
            result.put("uri", resource.getUri());
            result.put("res_type", BridgeService.ResponseType.PUT.name());

            String result_str = result.toString().replace("\\", "");
            service.broadcastResult(BridgeService.ResultType.OK.ordinal(), result_str);

        } catch (JSONException ex) {
            Log.e(TAG, "JSON Error : ", ex);
        }
        */

        // Observe the response of Post Request
        ObserveResponseHandler observerLight = new ObserveResponseHandler(service, resource, BridgeService.ResponseType.PUT);
        OcUtils.doObserve(resource.getUri(), Utils.getCoapsEndpoint(resource.getEndpoints()), null, observerLight, OCQos.LOW_QOS);

        // Stop Observe right after Observe
        // OcUtils.stopObserve(resource.getUri(), Utils.getCoapsEndpoint(resource.getEndpoints()));

        // Stop trigger register. It will be stop Observe after some secs
        //StopObserveTriggerHandler stopObserve = new StopObserveTriggerHandler(resource);
        //OcUtils.setDelayedHandler(stopObserve, 10);
    }
}
